﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Diagnostics;
using Infragistics.Olap.FlatData;
using Infragistics.Olap;
using System.Threading;
using Infragistics.Controls.Grids;

namespace xamPivotGrid1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            FlatDataSource dataSource = this.Resources["DataSource"] as FlatDataSource;
            dataSource.Cube = DataSourceBase.GenerateInitialCube("Sale");
            dataSource.Rows = DataSourceBase.GenerateInitialItems("[City].[City]");
            dataSource.Columns = DataSourceBase.GenerateInitialItems("[Product].[Product]");
            dataSource.Measures = DataSourceBase.GenerateInitialItems("AmountOfSale");
        }

        private void SortButton_Click(object sender, RoutedEventArgs e)
        {
            BackgroundWorker bw = new BackgroundWorker();
            bw.DoWork += new DoWorkEventHandler(bw_DoWork);
            bw.RunWorkerCompleted += new RunWorkerCompletedEventHandler(bw_RunWorkerCompleted);
            loaderMessage.Visibility = System.Windows.Visibility.Visible;
            bw.RunWorkerAsync();
        }

        void bw_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            loaderMessage.Visibility = System.Windows.Visibility.Collapsed;
        }

        void bw_DoWork(object sender, DoWorkEventArgs e)
        {
            this.Dispatcher.BeginInvoke((Action)(() =>
                    {
                        ISortableOlapDatasource ss =
                   this.pivotGrid.DataSource as ISortableOlapDatasource;
                        if (ss != null)
                        {
                            ss.Sort(
                            this.pivotGrid.DataSource.Result.ColumnAxis.Tuples[0],
                            _pivotSortDirection == PivotSortDirection.Ascending ? SortDirection.ASC : SortDirection.DESC, true);
                        }
                    }));
        }

        PivotSortDirection _pivotSortDirection = PivotSortDirection.Ascending;

        private void pivotGrid_ColumnSorting(object sender, Infragistics.Controls.Grids.PivotSortingCancellableEventArgs e)
        {
            BackgroundWorker bw = new BackgroundWorker();
            bw.DoWork += new DoWorkEventHandler(bw_DoWork);
            bw.RunWorkerCompleted += new RunWorkerCompletedEventHandler(bw_RunWorkerCompleted);
            loaderMessage.Visibility = System.Windows.Visibility.Visible;
            _pivotSortDirection = _pivotSortDirection == PivotSortDirection.Ascending ? PivotSortDirection.Descending : PivotSortDirection.Ascending;
            bw.RunWorkerAsync();
            loaderMessage.Visibility = System.Windows.Visibility.Visible;
            e.Cancel = true;
        }

        private void pivotGrid_ColumnSorted(object sender, Infragistics.Controls.Grids.PivotSortedColumnEventArgs e)
        {
            //loaderMessage.Visibility = System.Windows.Visibility.Collapsed;
        }
    }
}
