﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;

namespace xamPivotGrid1
{

    public class Manufacturer
    {
        /// <summary>
        /// A parameterised constructor for the Manufacturer class.
        /// </summary>
        /// <param name="name">The name of the manufacturer.</param>
        /// <param name="revenue">The manufacturer's revenue.</param>
        /// <param name="products">The products produced by the manufacturer.</param>
        public Manufacturer(string name, string revenue, IList<Product> products)
        {
            Name = name;
            Revenue = Int32.Parse(revenue);
            Products = products;
        }

        /// <summary>
        /// The name of the manufacturer.
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// The revenue of the manufacturer.
        /// </summary>
        public int Revenue { get; set; }

        /// <summary>
        /// The products produced by the manufacturer.
        /// </summary>
        public IList<Product> Products { get; set; }

        /// <summary>
        /// The number of products.
        /// </summary>
        public int ProductsCount { get { return Products.Count; } }
    }

    public class InventoryEntry
    {
        /// <summary>
        /// A parameterised constructor for the InventoryEntry class.
        /// </summary>
        /// <param name="shelf">The name of the shelf.</param>
        /// <param name="quantity">The number of products on the shelf.</param>
        public InventoryEntry(string shelf, string quantity)
        {
            Shelf = shelf;
            Quantity = Int32.Parse(quantity);
        }

        /// <summary>
        /// The name of the shelf.
        /// </summary>
        public string Shelf { get; set; }

        /// <summary>
        /// The number of products on the shelf.
        /// </summary>
        public int Quantity { get; set; }
    }
}
